﻿local dewdrop = AceLibrary("Dewdrop-2.0")
local tablet = AceLibrary("Tablet-2.0")
local crayon = AceLibrary("Crayon-2.0")

FactionItemsFu = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0", "FuBarPlugin-2.0")

FactionItemsFu.version       = "2.2.1." .. string.sub("$Revision: 65806 $", 12, -3)
FactionItemsFu.releaseDate   = string.sub("$Date: 2008-03-25 14:47:56 -0400 (Tue, 25 Mar 2008) $", 8, 17)
FactionItemsFu.hasIcon = true
FactionItemsFu.loc = FactionItemsFuLocals
FactionItemsFu.defaultPosition = 'LEFT'
FactionItemsFu.canHideText = false
FactionItemsFu.clickableTooltip = false

FactionItemsFu:RegisterDB("FactionItems2DB") -- ,"FactionItems2CharDB")

-- FactionItemsFu:RegisterDefaults('profile',{
	
-- })

FactionItemsFu:RegisterDefaults('char',{
        
TrackItems = {
	["Coarse Weightstone"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
    ["Small Furry Paw"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Copper Modulator"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Embossed Leather Boots"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=3,},
	["Torn Bear Pelt"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Heavy Grinding Stone"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=7,},
    ["Whirring Bronze Gizmo"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=7,},
    ["Toughened Leather Armor"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=3,},
	["Soft Bushy Tail"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Green Iron Bracers"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=3,},
    ["Green Firework"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=36,},
    ["Barbaric Harness"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=3,},
	["Vibrant Plume"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Big Black Mace"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Mechanical Repair Kit"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=6,},
    ["Turtle Scale Leggings"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
	["Glowing Scorpid Blood"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
    ["Evil Bat Eye"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
    ["Dense Grinding Stone"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=8,},
    ["Thorium Widget"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=6,},
	["Rugged Armor Kit"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=8,},
    ["Darkmoon Faire Prize Ticket"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
    ["Winterfall Spirit Beads"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Deadwood Headdress Feather"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
	["Encrypted Twilight Text"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
    ["Cenarion Combat Badge"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
    ["Cenarion Logistics Badge"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
    ["Cenarion Tactical Badge"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
	["Qiraji Regal Drape"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Bone Scarab"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Silver Scarab"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Stone Scarab"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Bronze Scarab"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Ivory Scarab"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
	["Crystal Scarab"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Qiraji Magisterial Ring"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Qiraji Ornate Hilt"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Jasper Idol"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Alibaster Idol"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
	["Vermillion Idol"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Qiraji Spiked Hilt"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Qiraji Ceremonial Ring"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Lambent Idol"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Amber Idol"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Azure Idol"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
	["Gold Scarab"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Clay Scarab"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Qiraji Martial Drape"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
		["Qiraji Lord's Insignia"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Obsidian Idol"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Onyx Idol"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Mark of Cenarius"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Mark of Remulos"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Abyssal Crest"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=3,},
		["Abyssal Signet"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=3,},
		["Abyssal Scepter"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=3,},
		["Twilight Cultist Medallion of Station"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
		["Twilight Cultist Ring of Lordship"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Troll Tribal Necklace"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
	["Coal"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Incendosaur Scales"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Kingsblood"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=4,},
    ["Heavy Leather"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=4,},
    ["Iron Bar"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=4,},
    ["Dark Iron Residue"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=4,},
    ["Dark Iron Ore"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
	["Core Leather"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Blood of the Mountain"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Lava Core"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Fiery Core"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Minion's Scourgestone"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=20,},
    ["Invader's Scourgestone"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
    ["Corruptor's Scourgestone"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
	["Runecloth"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
    ["Ectoplasmic Resonator"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=4,},
    ["Arcane Quickener"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Somatic Intensifier"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Osseous Agitator"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=6,},
    ["Argent Dawn Valor Token"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
	["Insignia of the Crusade"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
    ["Insignia of the Dawn"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
    ["Crypt Fiend Parts"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=30,},
    ["Core of Elements"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=30,},
    ["Savage Frond"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=30,},
    ["Dark Iron Scraps"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=30,},
    ["Bone Fragments"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=30,},
		["Healthy Dragon Scale"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Syndicate Emblem"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
		["Heavy Junkbox"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
    ["Qiraji Bindings of Dominance"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Qiraji Bindings of Command"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Idol of Strife"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
	  ["Idol of Rebirth"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Idol of War"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Skin of the Great Sandworm"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Idol of Life"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Vek'lor's Diadem"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Husk of the Old God"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Idol of the Sun"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Carapace of the Old God"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Idol of the Sage"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Idol of Death"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Ouro's Intact Hide"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
	["Vek'nilash's Circlet"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Idol of Night"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=2,},
    ["Purple Hakkari Bijou"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Green Hakkari Bijou"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Red Hakkari Bijou"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Yellow Hakkari Bijou"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Bronze Hakkari Bijou"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Gold Hakkari Bijou"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Orange Hakkari Bijou"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
	["Blue Hakkari Bijou"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Silver Hakkari Bijou"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Primal Hakkari Aegis"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Primal Hakkari Armsplint"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
	["Primal Hakkari Bindings"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Primal Hakkari Girdle"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Primal Hakkari Idol"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Primal Hakkari Kossock"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
	["Primal Hakkari Sash"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Primal Hakkari Shawl"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Primal Hakkari Stanchion"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Primal Hakkari Tabard"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
	["Zandalar Honor Token"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Sandfury Coin"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Skullsplitter Coin"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Bloodscalp Coin"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Gurubashi Coin"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
	["Vilebranch Coin"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Witherbark Coin"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Zulian Coin"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Razzashi Coin"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Hakkari Coin"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Wushoolay's Mane"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
	["Punctured Voodoo Doll"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Gri'lek's Blood"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Renataki's Tooth"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Hazza'rah's Dream Thread"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
    ["Morrowgrain"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
    ["Un'Goro soil"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
    ["Packet of Tharlendris Seeds"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]="(N/A)",},
		["Shardtooth Meat"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
		["Chillwind Meat"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
		["Obsidian Warbeads"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
		["Unidentified Plant Parts"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
		["Uncatalogued Species"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Coilfang Armaments"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Zaxxis Insignia"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
		["Pair of Ivory Tusks"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=3,},
		["Oshu'gun Crystal Fragment"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
		["Alterac Valley Mark of Honor"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Arathi Basin Mark of Honor"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Eye of the Storm Mark of Honor"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Warsong Gulch Mark of Honor"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Warsong Gulch Ribbon of Sacrafice"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Silverwing Talisman of Merit"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Mark of Honor Hold"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Mark of Thrallmar"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Bog Lord Tendril"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=6,},
		["Mature Spore Sac"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
		["Glowcap"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Fertile Spores"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
		["Sanguine Hibiscus"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=5,},
		["Mark of Kil'jaeden"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
		["Mark of Sargeras"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
		["Fel Armament"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
		["Holy Dust"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Dreadfang Venom Sac"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=8,},
		["Dampscale Basilisk Eye"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=8,},
		["Firewing Signet"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
		["Sunfury Signet"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=10,},
		["Arcane Tome"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=1,},
		["Arcane Rune"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=0,},
		["Arakkoa Feather"] = {["inv"] = 0,["bank"] = 0,["mail"]=0,["TurnIn"]=30,},
		
},
	["Argent Dawn"] = false,
	["Brood of Nozdormu"] = false,
  ["Cenarion Circle"] = false,
  ["Darkmoon Faire"] = true,
  ["Ravenholdt"] = false,
	["Thorium Brotherhood"] = false,
	["Timbermaw Hold"] = false,
	["Wildhammer Clan"] = false,
	["Zandalar Tribe"] = false,
  ["Capitals"] = false,
	["Wintersaber Trainers"] = false,
	["Cenarion Expedition"] = false,
	["The Consortium"] = false,
	["Kurenai"] = false,
	["Sporeggar"] = false,
	["PvP"] = false,
	["The Mag'har"] = false,
	["The Aldor"] = false,
	["The Scryers"] = false,
	["Lower City"] = false,
  ["countDisplayStyle"] = "none",
  ["title"] = false,
  ["AltChar"] = "none",
  })

	local optionsTable = { 
		type = 'group',
 		args = { 
            watch = { 
                name = "watch", 
                type = 'group',
                desc = "watch items for desired faction(s)",
                args = {
                    ["ArgentDawn"] = {
                        name = "Argent Dawn",type = 'toggle',
                        desc = "toggles watching items for Argent Dawn",
                        usage = "watch ArgentDawn",
                        get = function()
                            return FactionItemsFu.db.char["Argent Dawn"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Argent Dawn"] = not FactionItemsFu.db.char["Argent Dawn"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
                    ["BroodofNozdormu"] = {
                        name = "Brood of Nozdormu",type = 'toggle',
                        desc = "toggles watching items for Brood of Nozdormu",
                        usage = "watch BroodofNozdormu",
                        get = function()
                            return FactionItemsFu.db.char["Brood of Nozdormu"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Brood of Nozdormu"] = not FactionItemsFu.db.char["Brood of Nozdormu"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
                    ["CenarionCircle"] = {
                        name = "Cenarion Circle",type = 'toggle',
                        desc = "toggles watching items for Cenarion Circle",
                        usage = "watch CenarionCircle",
                        get = function()
                            return FactionItemsFu.db.char["Cenarion Circle"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Cenarion Circle"] = not FactionItemsFu.db.char["Cenarion Circle"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
                    ["DarkmoonFaire"] = {
                        name = "Darkmoon Faire",type = 'toggle',
                        desc = "toggles watching items for Darkmoon Faire",
                        usage = "watch DarkmoonFaire",
                        get = function()
                            return FactionItemsFu.db.char["Darkmoon Faire"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Darkmoon Faire"] = not FactionItemsFu.db.char["Darkmoon Faire"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
                    ["Ravenholdt"] = {
                        name = "Ravenholdt",type = 'toggle',
                        desc = "toggles watching items for Ravenholdt",
                        usage = "watch Ravenholdt",
                        get = function()
                            return FactionItemsFu.db.char["Ravenholdt"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Ravenholdt"] = not FactionItemsFu.db.char["Ravenholdt"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
                    ["ThoriumBrotherhood"] = {
                        name = "Thorium Brotherhood",type = 'toggle',
                        desc = "toggles watching items for Thorium Brotherhood",
                        usage = "watch ThoriumBrotherhood",
                        get = function()
                            return FactionItemsFu.db.char["Thorium Brotherhood"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Thorium Brotherhood"] = not FactionItemsFu.db.char["Thorium Brotherhood"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
                    ["TimbermawHold"] = {
                        name = "Timbermaw Hold",type = 'toggle',
                        desc = "toggles watching items for Timbermaw Hold",
                        usage = "watch TimbermawHold",
                        get = function()
                            return FactionItemsFu.db.char["Timbermaw Hold"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Timbermaw Hold"] = not FactionItemsFu.db.char["Timbermaw Hold"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
                    --[[ ["WildhammerClan"] = {
                        name = "Wildhammer Clan",type = 'toggle',
                        desc = "toggles watching items for Wildhammer Clan",
                        usage = "watch WildhammerClan",
                        get = function()
                            return FactionItemsFu.db.char["Wildhammer Clan"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Wildhammer Clan"] = not FactionItemsFu.db.char["Wildhammer Clan"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    }, --]] 
                    ["ZandalarTribe"] = {
                        name = "Zandalar Tribe",type = 'toggle',
                        desc = "toggles watching items for Zandalar Tribe",
                        usage = "watch ZandalarTribe",
                        get = function()
                            return FactionItemsFu.db.char["Zandalar Tribe"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Zandalar Tribe"] = not FactionItemsFu.db.char["Zandalar Tribe"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
									  ["Capitals"] = {
                        name = "Capitals",type = 'toggle',
                        desc = "toggles watching items for Morrowgrain and Cloth Quests",
                        usage = "watch Capitals",
                        get = function()
                            return FactionItemsFu.db.char["Capitals"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Capitals"] = not FactionItemsFu.db.char["Capitals"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
										["WintersaberTrainers"] = {
                        name = "Wintersaber Trainers",type = 'toggle',
                        desc = "toggles watching items for Wintersaber Trainers to get Epic Mount",
                        usage = "watch WintersaberTrainers",
                        get = function()
                            return FactionItemsFu.db.char["Wintersaber Trainers"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Wintersaber Trainers"] = not FactionItemsFu.db.char["Wintersaber Trainers"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
										["CenarionExpedition"] = {
                        name = "Cenarion Expedition",type = 'toggle',
                        desc = "toggles watching items for Cenarion Expedition in Outland",
                        usage = "watch CenarionExpedition",
                        get = function()
                            return FactionItemsFu.db.char["Cenarion Expedition"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Cenarion Expedition"] = not FactionItemsFu.db.char["Cenarion Expedition"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
										["Consortium"] = {
                        name = "The Consortium",type = 'toggle',
                        desc = "toggles watching items for The Consortium in Outland",
                        usage = "watch Consortium",
                        get = function()
                            return FactionItemsFu.db.char["The Consortium"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["The Consortium"] = not FactionItemsFu.db.char["The Consortium"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
										["Kurenai"] = {
                        name = "Kurenai",type = 'toggle',
                        desc = "toggles watching items for Kurenai in Outland",
                        usage = "watch Kurenai",
                        get = function()
                            return FactionItemsFu.db.char["Kurenai"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Kurenai"] = not FactionItemsFu.db.char["Kurenai"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
										["PvP"] = {
                        name = "PvP",type = 'toggle',
                        desc = "toggles watching awards for PvP in Battleground",
                        usage = "watch PvP",
                        get = function()
                            return FactionItemsFu.db.char["PvP"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["PvP"] = not FactionItemsFu.db.char["PvP"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
										["Sporeggar"] = {
                        name = "Sporeggar",type = 'toggle',
                        desc = "toggles watching items for Sporeggar in Outland",
                        usage = "watch Sporeggar",
                        get = function()
                            return FactionItemsFu.db.char["Sporeggar"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Sporeggar"] = not FactionItemsFu.db.char["Sporeggar"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
										["Mag'har"] = {
                        name = "Mag'har",type = 'toggle',
                        desc = "toggles watching items for Mag'har in Outland",
                        usage = "watch Mag'har",
                        get = function()
                            return FactionItemsFu.db.char["The Mag'har"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["The Mag'har"] = not FactionItemsFu.db.char["The Mag'har"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
										["Aldor"] = {
                        name = "The Aldor",type = 'toggle',
                        desc = "toggles watching items for The Aldor in Outland",
                        usage = "watch Aldor",
                        get = function()
                            return FactionItemsFu.db.char["The Aldor"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["The Aldor"] = not FactionItemsFu.db.char["The Aldor"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
										["Scryers"] = {
                        name = "The Scryers",type = 'toggle',
                        desc = "toggles watching items for The Scryers in Outland",
                        usage = "watch Scryers",
                        get = function()
                            return FactionItemsFu.db.char["The Scryers"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["The Scryers"] = not FactionItemsFu.db.char["The Scryers"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
										["LowerCity"] = {
                        name = "Lower City",type = 'toggle',
                        desc = "toggles watching items for Lower City in Outland",
                        usage = "watch LowerCity",
                        get = function()
                            return FactionItemsFu.db.char["Lower City"]
                        end,
                        set = function(v)
                            FactionItemsFu.db.char["Lower City"] = not FactionItemsFu.db.char["Lower City"]
                            --- Refresh in place
                            FactionItemsFu:UpdateDisplay()
                        end,
                        map = { [true] = "Watching", [false] = "Hidden" },
                    },
                },
            },
			panelDisplay = {
				name = "Panel_Display", 
        type = 'group',
              desc = "Text display configuration for FuBar panel",
              args = {
								["title"] = {
                	name = "Title",
									type = 'toggle',
                  desc = "toggles displaying addon title in FuBar panel",
                  usage = "panelDisplay title",
                  get = function()
                  	return FactionItemsFu.db.char.title
                  end,
                  set = function(v)
                  	FactionItemsFu.db.char.title = not FactionItemsFu.db.char.title
                    --- Refresh in place
                    FactionItemsFu:UpdateDisplay()
                  end,
                  map = { [true] = "Displayed", [false] = "Hidden" },
                },
                ["countDisplay"] = {
                  name = "countDisplay",
    							type = 'text',
    							desc = "toggles displaying bank and bags item totals in FuBar panel",
    							get = function()
        						return FactionItemsFu.db.char.countDisplayStyle
    							end,
    							set = function(option)
        						FactionItemsFu.db.char.countDisplayStyle = option
          					--- Refresh in place
        						FactionItemsFu:UpdateDisplay()
    							end,
    							validate = {"bags", "bank", "bankSlashbag","bagsPlusbank","none"},
								},
								["AltCharacter"] = {
                	name = "Alt Characters",
                	type = 'text',
                	desc = "Alt Character faction items to view",
                	get = function() FactionItemsFu.db.AltChar end,
                	set = function(altChar)
                		FactionItemsFu.db.AltChar = altChar
                	end,
                	validate = {"none"},
                },
							},
						},
 		},
	}

	FactionItemsFu:RegisterChatCommand({"/fi", "/fifu"},optionsTable)
	FactionItemsFu.OnMenuRequest = optionsTable
	
function FactionItemsFu:OnInitialize()
	ItemList = self.loc.TrackItems
	FactionList = self.loc.TrackFactions
	RepUnitNames = self.loc.RepNames
    FactionItemsList = self.loc.FactionItems
    if not self.db.char.Loaded then
		DEFAULT_CHAT_FRAME:AddMessage("No Database info preloaded")
		self.db.char.Loaded = true
    self.db.char.countDisplayStyle = "bankSlashbag"
    end
    TextTotals = {
        ["bags"] = 0,
        ["bank"] = 0,
        }
		CharList = self:GetCharListByServerId()
		table.insert(self.optionsTable.args.panelDisplay.args.AltCharacter.validate, CharList)
end

function FactionItemsFu:OnEnable()
	-- put something that would be run every time this is enabled. Happens at the very start as well, after Initialize.
	self:RegisterEvent("MERCHANT_SHOW","Inv_Change");
	self:RegisterEvent("MERCHANT_CLOSED","Inv_Change");
	self:RegisterEvent("MAIL_CLOSED","Mail_Change");
	self:RegisterEvent("BAG_UPDATE","Inv_Change");
	self:RegisterEvent("BANKFRAME_CLOSED","Bnk_Change");
	self:RegisterEvent("UNIT_INVENTORY_CHANGED","Inv_Change");
	self:RegisterEvent("BANKFRAME_OPENED","Bnk_Change");
	self:RegisterEvent("PLAYERBANKSLOTS_CHANGED","Bnk_Change");
    self:RegisterEvent("FACTION_STANDING_INCREASED","CheckFactionValue");
		
end

function FactionItemsFu:OnDisable()
	-- you do not need to unregister the event here, all events/hooks are unregistered on disable implicitly.
end

function FactionItemsFu:CheckFactionValue()
	-- CreateFactionList()
	self:UpdateDisplay()
end

function FactionItemsFu:Inv_Change()
  for _,k in pairs(ItemList)  do
    -- local ItemCount = GetBagItems(k)
		-- DEFAULT_CHAT_FRAME:AddMessage(k)
		local ItemCount = GetItemsInInv(k)
    self.db.char.TrackItems[k].inv = ItemCount
	end
	self:UpdateDisplay()
end

function FactionItemsFu:GetInvCount(k)
  return self.db.char.TrackItems[k].inv
	
end    

function FactionItemsFu:GetBankCount(k)
    return self.db.char.TrackItems[k].bank
    
end

function FactionItemsFu:GetMailCount(k)
  return self.db.char.TrackItems[k].mail
end

function FactionItemsFu:Bnk_Change()
  for _,k in pairs(ItemList)  do
    -- local ItemCount = GetBankItems(k)
		local ItemCount = GetItemsInBank(k)
    self.db.char.TrackItems[k].bank = ItemCount
  end
	self:UpdateDisplay()
end

function FactionItemsFu:Mail_Change()
  for _,k in pairs(ItemList)  do
    local ItemCount = GetMailItems(k)
    self.db.char.TrackItems[k].mail = ItemCount
  end
	
end

function FactionItemsFu:OnDataUpdate()
	TextTotals.bags = 0
  TextTotals.bank = 0
  for _,category in ipairs(FactionList) do
    local standing,bottomValue,maxNeeded,repValue = CheckFactionValues(category)
		if standing == nil then standing = 9 end
		if repValue == nil then repValue = 0 end
      if self.db.char[category] then
        if category == "Darkmoon Faire" then
					if standing == 9 or standing <= 4 then
						if repValue <= 500 then
							for _,items in ipairs(FactionItemsList["FaireTier1"]) do
								TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
                TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
							end
						end
						if repValue <= 1100 then
							for _,items in ipairs(FactionItemsList["FaireTier2"]) do
								TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
              	TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
							end
						end
						if repValue <= 1700 then
							for _,items in ipairs(FactionItemsList["FaireTier3"]) do
								TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
              	TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
							end
						end
						if repValue <= 2500 then
							for _,items in ipairs(FactionItemsList["FaireTier4"]) do
								TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
              	TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
							end
						end
					end
					for _,items in ipairs(FactionItemsList["FaireTier5"]) do
						TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
        		TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
					end
      	elseif category == "Thorium Brotherhood" then
          if standing == 9 or standing <= 8 then
            for _,items in ipairs(FactionItemsList["Brotherhood3"]) do
					    TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
              TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
				    end
          end
          if standing == 9 or standing <= 5 then
            for _,items in ipairs(FactionItemsList["Brotherhood2"]) do
					    TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
              TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
				    end
          end
          if standing == 9 or standing <= 4 then
            for _,items in ipairs(FactionItemsList["Brotherhood1"]) do
					    TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
              TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
				    end
          end
				elseif category == "The Consortium" then
          if standing <= 9 then
            for _,items in ipairs(FactionItemsList["Consortium1"]) do
					    TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
              TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
				    end
          end
          if standing == 9 or standing <= 8 then
            for _,items in ipairs(FactionItemsList["Consortium2"]) do
					    TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
              TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
				    end
          end
				elseif category == "Sporeggar" then
        	if standing == 9 or standing <= 5 then
          	for _,items in ipairs(FactionItemsList["Sporeggar1"]) do
				    	TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
            	TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
				  	end
        	end
        	if standing == 9 or standing <= 8 then
          	for _,items in ipairs(FactionItemsList["Sporeggar2"]) do
				    	TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
            	TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
				  	end
					end
				elseif category == "The Aldor" then
        if standing <= 9 then
          for _,items in ipairs(FactionItemsList["Aldor3"]) do
					  TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
           	TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
				  end
        end
        if standing == 9 or standing <= 5 then
          for _,items in ipairs(FactionItemsList["Aldor2"]) do
				  	TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
           	TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
				  end
        end
        if standing == 9 or standing < 4 then
          for _,items in ipairs(FactionItemsList["Aldor1"]) do
				  	TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
           	TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
				  end
        end	
			elseif category == "The Scryers" then
        if standing <= 9 then
          for _,items in ipairs(FactionItemsList["Scryers3"]) do
					  TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
           	TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
				  end
        end
        if standing == 9 or standing <= 5 then
          for _,items in ipairs(FactionItemsList["Scryers2"]) do
				  	TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
           	TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
				  end
        end
        if standing == 9 or standing < 4 then
          for _,items in ipairs(FactionItemsList["Scryers1"]) do
				  	TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
           	TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
				  end
        end	
			elseif category == "Lower City" then
        if standing == 9 or standing <= 5 then
          for _,items in ipairs(FactionItemsList["Lower City"]) do
				    TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
           	TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
				  end
        end		
			else
					for _,items in ipairs(FactionItemsList[category]) do
            TextTotals.bags = TextTotals.bags + self:GetInvCount(items)
            TextTotals.bank = TextTotals.bank + self:GetBankCount(items)
					end
			end
    end
  end
end 

function FactionItemsFu:GetItemTotals(itm)
	return self:GetInvCount(itm) + self:GetBankCount(itm) + self:GetMailCount(itm)
end

function FactionItemsFu:GetTurnInValue(itm)
	local turnInValue
	local temp = self.db.char.TrackItems[itm].TurnIn
	if temp == 0 then
		turnInValue = "(Varies)"
	else
		turnInValue = "("..temp..")"
	end
	return turnInValue
end

function FactionItemsFu:OnTextUpdate()
  self:UpdateData()
  textspace = " "
  if self.db.char["title"] then
		text = textspace..crayon:Green(self.loc.TEXT_SET)
  else
  	text = " "
  end
	if self.db.char["countDisplayStyle"] == "bankSlashbag" then
			text1 = textspace..crayon:White(TextTotals.bank).."/"..crayon:White(TextTotals.bags)
	elseif self.db.char["countDisplayStyle"] =="bagsPlusbank" then
			text1 = textspace..crayon:White(TextTotals.bank + TextTotals.bags)
	elseif self.db.char["countDisplayStyle"] =="bags" then
			text1 = textspace..crayon:White(TextTotals.bags)
	elseif self.db.char["countDisplayStyle"] == "bank" then
			text1 = textspace..crayon:White(TextTotals.bank)
	else
		text1 = ""
  end
	self:SetText(text..text1)
end
	
function FactionItemsFu:OnTooltipUpdate()

	for _,category in ipairs(FactionList) do
        local standing,bottomValue,maxNeeded,repValue = CheckFactionValues(category)
		if standing == nil then standing = 9 end
		if maxNeeded == nil then maxNeeded = 0 end
		if repValue == nil then repValue = 0 end
    if bottomValue == nil then bottomValue = 0 end
    if self.db.char[category] then
      cat = tablet:AddCategory(
        'columns', 3,
				'text', category,
				'text2',RepUnitNames[standing],
				'text3',(repValue - bottomValue).."/"..(maxNeeded - bottomValue).."   ",
				'text3R',0,
				'text3G',0,
				'text3B',1
			)
			cat:AddLine()
			cat:AddLine('text',"Item ",'text2',"Turn in",'text3'," Qty have")
			cat:AddLine()
			if category == "Darkmoon Faire" then
				if standing == 9 or standing <= 4 then
					if repValue <= 500 then
						for _,items in ipairs(FactionItemsList["FaireTier1"]) do
              cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
						end
					end
					if repValue <= 1000 then
						for _,items in ipairs(FactionItemsList["FaireTier2"]) do
              cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
						end
					end
					if repValue <= 1600 then
						for _,items in ipairs(FactionItemsList["FaireTier3"]) do
              cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
						end
					end
					if repValue <= 2500 then
						for _,items in ipairs(FactionItemsList["FaireTier4"]) do
              cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
						end
					end
				end
				for _,items in ipairs(FactionItemsList["FaireTier5"]) do
              cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				end
      elseif category == "Thorium Brotherhood" then
        if standing <= 9 then
          for _,items in ipairs(FactionItemsList["Brotherhood3"]) do
					  cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				  end
        end
        if standing == 9 or standing <= 5 then
          for _,items in ipairs(FactionItemsList["Brotherhood2"]) do
				  	cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				  end
        end
        if standing == 9 or standing <= 4 then
          for _,items in ipairs(FactionItemsList["Brotherhood1"]) do
				  	cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				  end
        end
			elseif category == "The Consortium" then
        if standing <= 9 then
          for _,items in ipairs(FactionItemsList["Consortium2"]) do
				    cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				  end
        end
        if standing == 9 or standing <= 4 then
          for _,items in ipairs(FactionItemsList["Consortium1"]) do
				    cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				  end
        end
			elseif category == "Sporeggar" then
        if standing == 9 or standing <= 5 then
          for _,items in ipairs(FactionItemsList["Sporeggar1"]) do
				    cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				  end
        end
        if standing == 9 or standing <= 8 then
          for _,items in ipairs(FactionItemsList["Sporeggar2"]) do
				    cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				  end
				end
			elseif category == "The Aldor" then
        if standing <= 9 then
          for _,items in ipairs(FactionItemsList["Aldor3"]) do
					  cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				  end
        end
        if standing == 9 or standing <= 5 then
          for _,items in ipairs(FactionItemsList["Aldor2"]) do
				  	cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				  end
        end
        if standing == 9 or standing < 4 then
          for _,items in ipairs(FactionItemsList["Aldor1"]) do
				  	cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				  end
        end	
			elseif category == "The Scryers" then
        if standing <= 9 then
          for _,items in ipairs(FactionItemsList["Scryers3"]) do
					  cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				  end
        end
        if standing == 9 or standing <= 5 then
          for _,items in ipairs(FactionItemsList["Scryers2"]) do
				  	cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				  end
        end
        if standing == 9 or standing < 4 then
          for _,items in ipairs(FactionItemsList["Scryers1"]) do
				  	cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				  end
        end	
			elseif category == "Lower City" then
        if standing == 9 or standing <= 5 then
          for _,items in ipairs(FactionItemsList["Lower City"]) do
				    cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				  end
        end	
			else
        for _,items in ipairs(FactionItemsList[category]) do
          cat:AddLine('text',items,'text2',self:GetTurnInValue(items),'text3',self:GetItemTotals(items).."   ",'text2R',1,'text2G',0,'text2B',0)
				end
			end
		end
	end
	tablet:SetHint("Click here will open Faction Grinder Settings if Installed.")
	-- as a rule, if you have an OnClick or OnDoubleClick or OnMouseUp or OnMouseDown, you should set a hint.
end

function FactionItemsFu:OnClick()
  if not IsShiftKeyDown() then
		local frame = getglobal("FactionGrinderSettingsFrame")
		if(frame)then
			if(frame:IsVisible())then
				frame:Hide()
				frame:ClearAllPoints()
      	frame:SetPoint("CENTER",nil,"CENTER",0,0)
			else
				frame:Show()
				frame:ClearAllPoints()
			end
		end
  else
	-- code for Shift Click
		-- local f = CreateFrame("Frame",nil,UIParent)
		-- f:SetFrameStrata("BACKGROUND")
		-- f:SetWidth(128)  -- Set These to whatever height/width is needed 
		-- f:SetHeight(64) -- for your Texture	
		-- f:Show()
  end
end
--------------------------------------------------------------------------------------------------
-- COUNT THE NUMBER OF ITEMS
--------------------------------------------------------------------------------------------------

function NameFromLink(link)
	local name
	if (link) then
		-- for name in string.gmatch(link, "|c%x+|Hitem:%d+:%d+:%d+:%d+|h%[(.-)%]|h|r") do
		name, link, quality, level, requiredlevel, class, subclass, stacksize, inventorytype, icon = GetItemInfo(link)
		return name
		-- end
	end
end 

function GetBagItems(argItem)
	local count = 0
	for bag = 4, 0, -1 do
		local size = GetContainerNumSlots(bag)
		if (size > 0) then
			for slot=1, size, 1 do
				local texture, itemCount = GetContainerItemInfo(bag, slot)
				if (itemCount ~= nil) then
				   local itemName = NameFromLink(GetContainerItemLink(bag, slot))	
					if  ((itemName) and (itemName ~= "")) then -- if the item has a name
                        if (itemName == argItem) then 
							count  = count + itemCount
						end
					end
				end
			end            
		end
	end	
	return count
end

function GetItemsInInv(argItem)
	count = GetItemCount(argItem)
  if (count) then
		return count
	else
		return 0
	end 
end

function GetItemsInBank(argItem)
	countBank = GetItemCount(argItem,true)
	countInv = GetItemCount(argItem,false)
  if (countBank) then
		return countBank - countInv
	else
		return 0
	end 
end

function GetMailItems(argItem)
	local count = 0
	local mailItems = GetInboxNumItems()
	if(mailItems > 0) then
		for index = 1, mailItems, 1 do
			itemName, itemIcon, itemQuantity = GetInboxItem(index)
			if( itemName == argItem ) then
			 count = count + itemQuantity
			end
		end
	end
	
	return count
end

function GetBankItems(argItem)
	local count = 0
		maxContainerItems = GetContainerNumSlots(BANK_CONTAINER)
		if ( maxContainerItems ) then
			for containerItemNum = 1, maxContainerItems do
				link = GetContainerItemLink(BANK_CONTAINER, containerItemNum)
				icon, quantity = GetContainerItemInfo(BANK_CONTAINER, containerItemNum)
				if( link ) then
				--LinkToName
					itemName = NameFromLink(link)
					if(itemName == argItem) then
						count = count + quantity
					end
				end
			end
		end
		for bagNum = 5, 11 do
			maxContainerItems = GetContainerNumSlots(bagNum)
			if( maxContainerItems ) then
				local id = BankButtonIDToInvSlotID(bagNum, 1)
				link = GetInventoryItemLink("player", id)
				icon = GetInventoryItemTexture("player", id)
				for containerItemNum = 1, maxContainerItems do
					link = GetContainerItemLink(bagNum, containerItemNum)
					icon, quantity = GetContainerItemInfo(bagNum, containerItemNum)
					if( link ) then
					--LinkToName
						itemName = NameFromLink(link)
						if(itemName == argItem) then
							count = count + quantity
						end
					end
				end
			end
		end
	
	return count
end

--------------------------------------------------------------------------------------------------
-- Reputation Functions
--------------------------------------------------------------------------------------------------

function CheckFactionValues(f)
	local numFactions = GetNumFactions()
		for factionIndex=1, numFactions do
			name, _, standingID, bottomValue, topValue, barValue, _, _, isHeader, isCollapsed,_ = GetFactionInfo(factionIndex)
			if isHeader == nil then 
			  isHeader = false
			end
			if isHeader then
				if isCollapsed then
					ExpandFactionHeader(factionIndex)
				end
			elseif name == f then
				return standingID,bottomValue,topValue,barValue
			end
		end
end

--------------------------------------------------------------------------------------------------
-- Alt Char Functions
-------------------------------------------------------------------------------------------------

function FactionItemsFu:GetCharListByServerId()
    local list = {}
    for k, v in pairs(self.db.account) do
        if type(v) == "table" then
            for k2, v2 in pairs(v) do
                local _, _, name, server = string.find(k2, "(.+) %- (.+)")
                if not server then _, _, name, server = string.find(k2, L["Player of Realm"]) end
                if not server then _, _, name, server = string.find(k2, "(.+) of (.+)") end
                serverId = format("%s - %s",  server, k)
                
                
                if not list[serverId] then list[serverId] = {} end
                table.insert(list[serverId], string.format("%s - %s", name, k2) )
                sort(list[serverId])
            end
        end
    end
    return list
end

--------------------------------------------------------------------------------------------------
-- Misc Help Functions
-------------------------------------------------------------------------------------------------

function FactionItemsFu:Round(num)
	if(num - math.floor(num) >= 0.5) then
		num = num + 0.5;
	end
	return math.floor(num)
end

function Min(num1,num2)
  if(num1<=num2) then
	ret=num1
  else
	ret=num2
  end

  return ret
end 


